apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ jvb_name }}
  name: {{ jvb_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ jvb_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ jvb_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ jvb_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ jvb_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ jvb_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ jvb_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DOCKER_HOST_ADDRESS
{% if (jvb_found_external_ip | default(False)) != False %}
          value: {{ jvb_found_external_ip }}
{% else %}
          valueFrom:
            fieldRef:
              fieldPath: spec.nodeName
{% endif %}
        - name: ENABLE_AUTH
          value: "{{ 1 if (do_ldap) else 0 }}"
        - name: ENABLE_GUESTS
          value: "{{ 1 if (jitsi_enable_guests) else 0 }}"
        - name: JICOFO_AUTH_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ jicofo_name }}
        - name: JICOFO_AUTH_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ jicofo_name }}
        - name: JVB_AUTH_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ jvb_name }}
        - name: JVB_AUTH_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ jvb_name }}
        - name: JVB_BREWERY_MUC
          value: jvbbrewery
        - name: JVB_ENABLE_APIS
          value: rest,colibri
        - name: JVB_OPTS
          value: --apis=rest
        - name: JVB_PORT
          value: "{{ jvb_found_external_port | default(jvb_external_port) }}"
        - name: JVB_STUN_SERVERS
{% if jvb_stun_servers | length > 0 %}
          value: "{{ jvb_stun_servers | join(',') }}"
{% else %}
          value: ""
{% endif %}
        - name: JVB_TCP_HARVESTER_DISABLED
          value: "1"
        - name: PUBLIC_URL
          value: https://{{ jitsi_fqdn }}
        - name: TZ
          value: {{ timezone }}
        - name: XMPP_AUTH_DOMAIN
          value: auth.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_DOMAIN
          value: meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_GUEST_DOMAIN
          value: guest.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_INTERNAL_MUC_DOMAIN
          value: internal-muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_MUC_DOMAIN
          value: muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_RECORDER_DOMAIN
          value: recorder.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_SERVER
          value: {{ prosody_name }}.{{ namespace }}.svc.{{ cluster_domain }}
{% if do_triggers == False or (opsimages | json_query("[?name=='jvb'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='jvb'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 10
{% endif %}
          tcpSocket:
            port: 8080
          periodSeconds: 30
          timeoutSeconds: 5
        name: jvb
        ports:
        - containerPort: 8080
          name: health
        - containerPort: {{ jvb_external_port | int }}
          name: jvb
          protocol: UDP
        readinessProbe:
          failureThreshold: 10
          httpGet:
            path: /about/health
            port: 8080
          periodSeconds: 30
          timeoutSeconds: 10
        resources:
          limits:
            cpu: "{{ jvb_cpu_limit }}"
            memory: "{{ jvb_memory_limit }}"
          requests:
            cpu: "{{ jvb_cpu_request }}"
            memory: "{{ jvb_memory_request }}"
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /config
          name: data
{% if do_exporters %}
      - command:
        - /prometheus-jitsi-meet-exporter
        - -videobridge-url
        - http://127.0.0.1:8080/colibri/stats
        name: exporter
{% if do_triggers == False or (opsimages | json_query("[?name=='jvbexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='jvbexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        ports:
        - containerPort: 9888
          name: tcp-metrics
        readinessProbe:
          httpGet:
            path: /health
            port: 9888
          initialDelaySeconds: 3
          periodSeconds: 5
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: {{ exporter_memory_limit }}
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: {{ exporter_memory_request }}
{% if k8s_flavor == 'kubernetes' %}
        securityContext:
          runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          httpGet:
            path: /about/health
            port: 8080
          timeoutSeconds: 5
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      serviceAccountName: {{ jitsi_name }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ jvb_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ jvb_name }}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='jvb'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - jvb
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='jvb'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='jvbexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='jvbexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
